"use strict";

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Form = void 0;

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var list_1 = __importDefault(require("../list"));

var rc_field_form_1 = __importDefault(require("rc-field-form"));

var context_1 = require("./context");

var with_default_props_1 = require("../../utils/with-default-props");

var defaultProps = {
  hasFeedback: true,
  layout: 'vertical'
};

exports.Form = function (p) {
  var props = with_default_props_1.mergeProps(defaultProps, p);

  var className = props.className,
      style = props.style,
      hasFeedback = props.hasFeedback,
      children = props.children,
      layout = props.layout,
      footer = props.footer,
      formProps = __rest(props, ["className", "style", "hasFeedback", "children", "layout", "footer"]);

  return react_1["default"].createElement(rc_field_form_1["default"], Object.assign({
    className: classnames_1["default"]('am-form', className),
    style: style
  }, formProps), react_1["default"].createElement(list_1["default"], {
    style: {
      '--prefix-width': '6em',
      '--align-items': 'stretch'
    }
  }, react_1["default"].createElement(context_1.FormContext.Provider, {
    value: {
      hasFeedback: hasFeedback,
      layout: layout
    }
  }, children)), footer && react_1["default"].createElement("div", {
    className: 'am-form-footer'
  }, footer));
};