"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.showMultiImageViewer = exports.showImageViewer = exports.MultiImageViewer = exports.ImageViewer = void 0;

var with_default_props_1 = require("../../utils/with-default-props");

var render_to_container_1 = require("../../utils/render-to-container");

var mask_1 = __importDefault(require("../mask"));

var slide_1 = require("./slide");

var slides_1 = require("./slides");

var react_1 = __importStar(require("react"));

var render_to_body_1 = require("../../utils/render-to-body");

var classPrefix = "am-image-viewer";
var defaultProps = {
  maxZoom: 3,
  getContainer: null,
  visible: false
};
exports.ImageViewer = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var node = react_1["default"].createElement(mask_1["default"], {
    visible: props.visible,
    disableBodyScroll: false,
    opacity: 'dark',
    afterClose: props.afterClose
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-content"
  }, props.image && react_1["default"].createElement(slide_1.Slide, {
    image: props.image,
    onTap: function onTap() {
      var _a;

      (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props);
    },
    maxZoom: props.maxZoom
  })));
  return render_to_container_1.renderToContainer(props.getContainer, node);
});
var multiDefaultProps = Object.assign(Object.assign({}, defaultProps), {
  defaultIndex: 0
});
exports.MultiImageViewer = with_default_props_1.withDefaultProps(multiDefaultProps)(function (props) {
  var node = react_1["default"].createElement(mask_1["default"], {
    visible: props.visible,
    disableBodyScroll: false,
    opacity: 'dark',
    afterClose: props.afterClose
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-content"
  }, props.images && react_1["default"].createElement(slides_1.Slides, {
    defaultIndex: props.defaultIndex,
    onIndexChange: props.onIndexChange,
    images: props.images,
    onTap: function onTap() {
      var _a;

      (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props);
    },
    maxZoom: props.maxZoom
  })));
  return render_to_container_1.renderToContainer(props.getContainer, node);
});

function showImageViewer(props) {
  var Wrapper = react_1.forwardRef(function (_, ref) {
    var _react_1$useState = react_1.useState(true),
        visible = _react_1$useState[0],
        setVisible = _react_1$useState[1];

    react_1.useImperativeHandle(ref, function () {
      return {
        close: function close() {
          setVisible(false);
        }
      };
    });
    return react_1["default"].createElement(exports.ImageViewer, Object.assign({}, props, {
      visible: visible,
      onClose: function onClose() {
        var _a;

        (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props);
        setVisible(false);
      },
      afterClose: function afterClose() {
        var _a;

        (_a = props.afterClose) === null || _a === void 0 ? void 0 : _a.call(props);
        unmount();
      }
    }));
  });
  var ref = react_1.createRef();
  var unmount = render_to_body_1.renderToBody(react_1["default"].createElement(Wrapper, {
    ref: ref
  }));
  return {
    close: function close() {
      var _a;

      (_a = ref.current) === null || _a === void 0 ? void 0 : _a.close();
    }
  };
}

exports.showImageViewer = showImageViewer;

function showMultiImageViewer(props) {
  var Wrapper = react_1.forwardRef(function (_, ref) {
    var _react_1$useState2 = react_1.useState(true),
        visible = _react_1$useState2[0],
        setVisible = _react_1$useState2[1];

    react_1.useImperativeHandle(ref, function () {
      return {
        close: function close() {
          setVisible(false);
        }
      };
    });
    return react_1["default"].createElement(exports.MultiImageViewer, Object.assign({}, props, {
      visible: visible,
      onClose: function onClose() {
        var _a;

        (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props);
        setVisible(false);
      },
      afterClose: function afterClose() {
        var _a;

        (_a = props.afterClose) === null || _a === void 0 ? void 0 : _a.call(props);
        unmount();
      }
    }));
  });
  var ref = react_1.createRef();
  var unmount = render_to_body_1.renderToBody(react_1["default"].createElement(Wrapper, {
    ref: ref
  }));
  return {
    close: function close() {
      var _a;

      (_a = ref.current) === null || _a === void 0 ? void 0 : _a.close();
    }
  };
}

exports.showMultiImageViewer = showMultiImageViewer;