"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabBar = exports.TabBarItem = void 0;

var react_1 = __importDefault(require("react"));

var ahooks_1 = require("ahooks");

var classnames_1 = __importDefault(require("classnames"));

var badge_1 = __importDefault(require("../badge"));

exports.TabBarItem = function () {
  return null;
};

exports.TabBar = function (props) {
  var firstActiveKey = undefined;
  var items = [];
  react_1["default"].Children.forEach(props.children, function (child, index) {
    if (!react_1["default"].isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;

    if (index === 0) {
      firstActiveKey = key;
    }

    items.push(child);
  });

  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    valuePropName: 'activeKey',
    defaultValuePropName: 'defaultActiveKey',
    defaultValue: firstActiveKey,
    trigger: 'onChange'
  }),
      activeKey = _ahooks_1$useControll[0],
      setActiveKey = _ahooks_1$useControll[1];

  return react_1["default"].createElement("div", {
    className: classnames_1["default"]('am-tab-bar', props.className),
    style: props.style
  }, items.map(function (item) {
    function renderContent() {
      var iconElement = item.props.icon && react_1["default"].createElement("div", {
        className: 'am-tab-bar-item-icon'
      }, item.props.icon);
      var titleElement = item.props.title && react_1["default"].createElement("div", {
        className: 'am-tab-bar-item-title'
      }, item.props.title);

      if (item.props.badge !== undefined) {
        if (iconElement) {
          return react_1["default"].createElement(react_1["default"].Fragment, null, react_1["default"].createElement(badge_1["default"], {
            content: item.props.badge,
            offset: [0, 6]
          }, iconElement), titleElement);
        } else if (titleElement) {
          return react_1["default"].createElement(react_1["default"].Fragment, null, react_1["default"].createElement(badge_1["default"], {
            content: item.props.badge,
            offset: [2, -2]
          }, titleElement));
        }
      } else {
        return react_1["default"].createElement(react_1["default"].Fragment, null, iconElement, titleElement);
      }

      return null;
    }

    return react_1["default"].createElement("div", {
      key: item.key,
      onClick: function onClick() {
        var key = item.key;
        if (key === undefined || key === null) return;
        setActiveKey(key.toString());
      },
      className: classnames_1["default"]('am-tab-bar-item', item.props.className, {
        'am-tab-bar-item-active': item.key === activeKey
      })
    }, renderContent());
  }));
};