import React, { useContext } from 'react';
import classNames from 'classnames';
import { useControllableValue } from 'ahooks';
import { CheckOutlined } from '@ant-design/icons';
import { CheckboxGroupContext } from './group-context';
var classPrefix = "am-checkbox";
export var Checkbox = function Checkbox(props) {
  var _classNames;

  var groupContext = useContext(CheckboxGroupContext);

  var _useControllableValue = useControllableValue(props, {
    valuePropName: 'checked',
    defaultValuePropName: 'defaultChecked',
    defaultValue: false
  }),
      checked = _useControllableValue[0],
      setChecked = _useControllableValue[1];

  var disabled = props.disabled;
  var value = props.value;

  if (groupContext && value !== undefined) {
    checked = groupContext.value.includes(value);

    setChecked = function setChecked(checked) {
      var _a;

      if (checked) {
        groupContext.check(value);
      } else {
        groupContext.uncheck(value);
      }

      (_a = props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, checked);
    };

    disabled = disabled || groupContext.disabled;
  }

  return /*#__PURE__*/React.createElement("label", {
    className: classNames(classPrefix, props.className, (_classNames = {}, _classNames[classPrefix + "-checked"] = checked, _classNames[classPrefix + "-indeterminate"] = props.indeterminate, _classNames[classPrefix + "-disabled"] = disabled, _classNames[classPrefix + "-block"] = props.block, _classNames)),
    style: props.style
  }, /*#__PURE__*/React.createElement("input", {
    type: 'checkbox',
    checked: checked,
    onChange: function onChange(e) {
      setChecked(e.target.checked);
    },
    onClick: function onClick(e) {
      e.stopPropagation();
      e.nativeEvent.stopImmediatePropagation();
    },
    disabled: disabled
  }), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-icon"
  }, /*#__PURE__*/React.createElement(CheckOutlined, {
    className: classPrefix + "-icon-checked"
  }), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-indeterminate-checked"
  })), props.children && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-content"
  }, props.children));
};