import React from 'react';
import { useControllableValue } from 'ahooks';
import classnames from 'classnames';
import { mergeProps } from '../../utils/with-default-props';
import Icon from '@ant-design/icons';
import { IconEye } from '../icons/icon-eye';
import { IconEyeClose } from '../icons/icon-eye-close';
var defaultProps = {
  defaultDesense: true
};
export var DesenseText = function DesenseText(p) {
  var props = mergeProps(defaultProps, p);
  var text = props.text,
      desenseText = props.desenseText;

  var _useControllableValue = useControllableValue(props, {
    valuePropName: 'desense',
    defaultValuePropName: 'defaultDesense'
  }),
      isDesense = _useControllableValue[0],
      setIsDesense = _useControllableValue[1];

  return /*#__PURE__*/React.createElement("span", {
    className: classnames('am-desense-text', props.className),
    style: props.style
  }, isDesense ? desenseText : text, /*#__PURE__*/React.createElement("a", {
    className: classnames('am-desense-text-icon-wrap', 'am-plain-anchor'),
    onClick: function onClick() {
      setIsDesense(!isDesense);
    }
  }, /*#__PURE__*/React.createElement(Icon, {
    component: isDesense ? IconEyeClose : IconEye
  })));
};