import React, { useState, useRef } from 'react';
import classNames from 'classnames';
import Input from '../input';
import { withDefaultProps } from '../../utils/with-default-props';
import { SearchOutlined } from '@ant-design/icons';
import { useControllableValue } from 'ahooks';
var classPrefix = "am-search";
var defaultProps = {
  clearable: true,
  showCancelButton: false
};
export var Search = withDefaultProps(defaultProps)(function (props) {
  var _classNames;

  var _useControllableValue = useControllableValue(props, {
    defaultValue: ''
  }),
      value = _useControllableValue[0],
      setValue = _useControllableValue[1];

  var _useState = useState(false),
      hasFocus = _useState[0],
      setHasFocus = _useState[1];

  var inputRef = useRef(null);
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix, props.className, (_classNames = {}, _classNames[classPrefix + "-active"] = hasFocus, _classNames)),
    style: props.style
  }, /*#__PURE__*/React.createElement("form", {
    className: classPrefix + "-input-box",
    action: '/',
    onSubmit: function onSubmit(e) {
      var _a, _b;

      e.preventDefault();
      e.stopPropagation();
      (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.blur();
      (_b = props.onSearch) === null || _b === void 0 ? void 0 : _b.call(props, value);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-input-box-icon"
  }, /*#__PURE__*/React.createElement(SearchOutlined, null)), /*#__PURE__*/React.createElement(Input, {
    ref: inputRef,
    className: classPrefix + "-input",
    value: value,
    onChange: setValue,
    maxLength: props.maxLength,
    placeholder: props.placeholder,
    clearable: props.clearable,
    onFocus: function onFocus() {
      var _a;

      setHasFocus(true);
      (_a = props.onFocus) === null || _a === void 0 ? void 0 : _a.call(props);
    },
    onBlur: function onBlur() {
      var _a;

      setHasFocus(false);
      (_a = props.onBlur) === null || _a === void 0 ? void 0 : _a.call(props);
    },
    onClear: props.onClear,
    type: 'search'
  })), props.showCancelButton && hasFocus && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-suffix"
  }, /*#__PURE__*/React.createElement("a", {
    onMouseDown: function onMouseDown(e) {
      e.preventDefault();
    },
    onTouchStart: function onTouchStart(e) {
      e.preventDefault();
    },
    onClick: function onClick() {
      var _a, _b, _c;

      (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.clear();
      (_b = inputRef.current) === null || _b === void 0 ? void 0 : _b.blur();
      (_c = props.onCancel) === null || _c === void 0 ? void 0 : _c.call(props);
    }
  }, "\u53D6\u6D88")));
});