"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DesenseText = void 0;

var react_1 = __importDefault(require("react"));

var ahooks_1 = require("ahooks");

var classnames_1 = __importDefault(require("classnames"));

var with_default_props_1 = require("../../utils/with-default-props");

var icons_1 = __importDefault(require("@ant-design/icons"));

var icon_eye_1 = require("../icons/icon-eye");

var icon_eye_close_1 = require("../icons/icon-eye-close");

var defaultProps = {
  defaultDesense: true
};

exports.DesenseText = function (p) {
  var props = with_default_props_1.mergeProps(defaultProps, p);
  var text = props.text,
      desenseText = props.desenseText;

  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    valuePropName: 'desense',
    defaultValuePropName: 'defaultDesense'
  }),
      isDesense = _ahooks_1$useControll[0],
      setIsDesense = _ahooks_1$useControll[1];

  return react_1["default"].createElement("span", {
    className: classnames_1["default"]('am-desense-text', props.className),
    style: props.style
  }, isDesense ? desenseText : text, react_1["default"].createElement("a", {
    className: classnames_1["default"]('am-desense-text-icon-wrap', 'am-plain-anchor'),
    onClick: function onClick() {
      setIsDesense(!isDesense);
    }
  }, react_1["default"].createElement(icons_1["default"], {
    component: isDesense ? icon_eye_close_1.IconEyeClose : icon_eye_1.IconEye
  })));
};