"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Cascader = void 0;

var react_1 = __importStar(require("react"));

var picker_1 = require("./picker");

exports.Cascader = function (props) {
  var options = props.options,
      pickerProps = __rest(props, ["options"]);

  var _react_1$useMemo = react_1.useMemo(function () {
    var depth = 1;
    var subOptionsRecord = {};

    function traverse(option, currentDepth) {
      if (!option.children) {
        return;
      }

      subOptionsRecord[option.value] = option.children;
      var nextDepth = currentDepth + 1;

      if (nextDepth > depth) {
        depth = nextDepth;
      }

      option.children.forEach(function (option) {
        traverse(option, nextDepth);
      });
    }

    options.forEach(function (option) {
      traverse(option, 1);
    });
    return {
      depth: depth,
      subOptionsRecord: subOptionsRecord
    };
  }, [options]),
      depth = _react_1$useMemo.depth,
      subOptionsRecord = _react_1$useMemo.subOptionsRecord;

  function columns(value) {
    var columns = [];
    columns.push(options.map(function (option) {
      return {
        label: option.label,
        value: option.value
      };
    }));

    for (var i = 0; i < depth - 1; i++) {
      var x = value[i];
      var subOptions = subOptionsRecord[x];

      if (!subOptions) {
        columns.push([]);
      } else {
        columns.push(subOptions.map(function (option) {
          return {
            label: option.label,
            value: option.value
          };
        }));
      }
    }

    return columns;
  }

  return react_1["default"].createElement(picker_1.Picker, Object.assign({}, pickerProps, {
    columns: columns
  }));
};