"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Picker = void 0;

var react_1 = __importStar(require("react"));

var popup_1 = __importDefault(require("../popup"));

var ahooks_1 = require("ahooks");

var column_1 = require("./column");

var with_default_props_1 = require("../../utils/with-default-props");

var classnames_1 = __importDefault(require("classnames"));

var classPrefix = "am-picker";
exports.Picker = with_default_props_1.withDefaultProps({
  confirmText: '确定',
  cancelText: '取消'
})(function (props) {
  var _a;

  var controllable = ahooks_1.useControllableValue(props, {
    trigger: 'onConfirm',
    defaultValue: []
  });
  var value = controllable[0];
  var setValue = controllable[1];

  var _react_1$useState = react_1.useState(value),
      innerValue = _react_1$useState[0],
      setInnerValue = _react_1$useState[1];

  react_1.useEffect(function () {
    if (!props.visible) {
      setInnerValue(value);
    }
  }, [props.visible]);
  react_1.useEffect(function () {
    if (!props.visible) {
      setInnerValue(value);
    }
  }, [value]);
  var columns = react_1.useMemo(function () {
    var columns = typeof props.columns === 'function' ? props.columns(innerValue) : props.columns;
    return columns.map(function (column) {
      return column.map(function (item) {
        return typeof item === 'string' ? {
          label: item,
          value: item
        } : item;
      });
    });
  }, [props.columns, innerValue]);
  var widget = react_1["default"].createElement(popup_1["default"], {
    visible: props.visible,
    position: 'bottom',
    onMaskClick: function onMaskClick() {
      var _a, _b;

      (_a = props.onCancel) === null || _a === void 0 ? void 0 : _a.call(props);
      (_b = props.onClose) === null || _b === void 0 ? void 0 : _b.call(props);
    },
    getContainer: props.getContainer,
    destroyOnClose: true,
    afterShow: props.afterShow,
    afterClose: props.afterClose,
    onClick: props.onClick
  }, react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, props.className),
    style: props.style
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-header"
  }, react_1["default"].createElement("a", {
    className: classPrefix + "-header-button",
    onClick: function onClick() {
      var _a, _b;

      (_a = props.onCancel) === null || _a === void 0 ? void 0 : _a.call(props);
      (_b = props.onClose) === null || _b === void 0 ? void 0 : _b.call(props);
    }
  }, props.cancelText), react_1["default"].createElement("a", {
    className: classPrefix + "-header-button",
    onClick: function onClick() {
      var _a;

      setValue(innerValue);
      (_a = props.onClose) === null || _a === void 0 ? void 0 : _a.call(props);
    }
  }, props.confirmText)), react_1["default"].createElement("div", {
    className: classPrefix + "-columns"
  }, columns.map(function (column, index) {
    return react_1["default"].createElement(column_1.Column, {
      key: index,
      column: column,
      value: innerValue[index],
      onSelect: function onSelect(val) {
        setInnerValue(function (prev) {
          var _a;

          var nextValue = [].concat(prev);
          nextValue[index] = val;
          (_a = props.onSelect) === null || _a === void 0 ? void 0 : _a.call(props, nextValue);
          return nextValue;
        });
      }
    });
  }), react_1["default"].createElement("div", {
    className: classPrefix + "-mask " + classPrefix + "-mask-top"
  }), react_1["default"].createElement("div", {
    className: classPrefix + "-mask " + classPrefix + "-mask-bottom"
  }))));
  var items = react_1.useMemo(function () {
    return value.map(function (v, index) {
      var _a;

      var column = columns[index];
      if (!column) return null;
      return (_a = column.find(function (item) {
        return item.value === v;
      })) !== null && _a !== void 0 ? _a : null;
    });
  }, [value, columns]);
  return react_1["default"].createElement(react_1["default"].Fragment, null, widget, (_a = props.children) === null || _a === void 0 ? void 0 : _a.call(props, items));
});