import classNames from 'classnames';
import React from 'react';
import { convertPx } from '../../utils/convert-px';
import { withDefaultProps } from '../../utils/with-default-props';
var classPrefix = "am-badge";
export var Badge = withDefaultProps({
  color: '#FF411C',
  offset: [0, 0]
})(function (props) {
  var _classNames;

  var content = props.content,
      color = props.color,
      offset = props.offset,
      children = props.children;
  var badgeStyle = children ? {
    right: -convertPx(offset[0]) + "px",
    top: convertPx(offset[1]) + "px",
    backgroundColor: color
  } : {
    backgroundColor: color
  };
  var badgeCls = classNames(classPrefix, (_classNames = {}, _classNames[classPrefix + "-fixed"] = !!children, _classNames[classPrefix + "-dot"] = !content, _classNames));
  return children ? /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix + "-wrap", props.className),
    style: props.style
  }, children, /*#__PURE__*/React.createElement("div", {
    className: badgeCls,
    style: badgeStyle
  }, content)) : /*#__PURE__*/React.createElement("div", {
    className: classNames(badgeCls, props.className),
    style: Object.assign(Object.assign({}, badgeStyle), props.style)
  }, content);
});