import { withDefaultProps } from '../../utils/with-default-props';
import React from 'react';
import classNames from 'classnames';
var classPrefix = "am-grid";
var defaultProps = {
  gap: 0
};
export var Grid = withDefaultProps(defaultProps)(function (props) {
  var gapStyle = {};

  if (props.style) {
    gapStyle = Object.assign(Object.assign({}, gapStyle), props.style);
  }

  var gap = props.gap;

  if (gap) {
    var _ref = Array.isArray(gap) ? gap : [gap, gap],
        horizontalGap = _ref[0],
        verticalGap = _ref[1];

    gapStyle = Object.assign(Object.assign({}, gapStyle), {
      '--vertical-gap': typeof verticalGap === 'number' ? verticalGap + "px" : verticalGap,
      '--horizontal-gap': typeof horizontalGap === 'number' ? horizontalGap + "px" : horizontalGap
    });
  }

  return /*#__PURE__*/React.createElement("div", {
    className: classNames("" + classPrefix, props.className),
    style: Object.assign(Object.assign({}, gapStyle), {
      '--columns': props.columns
    })
  }, props.children);
});
export var GridItem = withDefaultProps({
  span: 1
})(function (props) {
  var _a;

  var itemStyle = (_a = props.style) !== null && _a !== void 0 ? _a : {};
  itemStyle = Object.assign(Object.assign({}, itemStyle), {
    '--item-span': props.span
  });
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix + "-item", props.className),
    style: itemStyle
  }, props.children);
});