import React from 'react';
import { useControllableValue } from 'ahooks';
import classNames from 'classnames';
import Badge from '../badge';
export var TabBarItem = function TabBarItem() {
  return null;
};
export var TabBar = function TabBar(props) {
  var firstActiveKey = undefined;
  var items = [];
  React.Children.forEach(props.children, function (child, index) {
    if (! /*#__PURE__*/React.isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;

    if (index === 0) {
      firstActiveKey = key;
    }

    items.push(child);
  });

  var _useControllableValue = useControllableValue(props, {
    valuePropName: 'activeKey',
    defaultValuePropName: 'defaultActiveKey',
    defaultValue: firstActiveKey,
    trigger: 'onChange'
  }),
      activeKey = _useControllableValue[0],
      setActiveKey = _useControllableValue[1];

  return /*#__PURE__*/React.createElement("div", {
    className: classNames('am-tab-bar', props.className),
    style: props.style
  }, items.map(function (item) {
    function renderContent() {
      var iconElement = item.props.icon && /*#__PURE__*/React.createElement("div", {
        className: 'am-tab-bar-item-icon'
      }, item.props.icon);
      var titleElement = item.props.title && /*#__PURE__*/React.createElement("div", {
        className: 'am-tab-bar-item-title'
      }, item.props.title);

      if (item.props.badge !== undefined) {
        if (iconElement) {
          return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Badge, {
            content: item.props.badge,
            offset: [0, 6]
          }, iconElement), titleElement);
        } else if (titleElement) {
          return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Badge, {
            content: item.props.badge,
            offset: [2, -2]
          }, titleElement));
        }
      } else {
        return /*#__PURE__*/React.createElement(React.Fragment, null, iconElement, titleElement);
      }

      return null;
    }

    return /*#__PURE__*/React.createElement("div", {
      key: item.key,
      onClick: function onClick() {
        var key = item.key;
        if (key === undefined || key === null) return;
        setActiveKey(key.toString());
      },
      className: classNames('am-tab-bar-item', item.props.className, {
        'am-tab-bar-item-active': item.key === activeKey
      })
    }, renderContent());
  }));
};