import React from 'react';
import { mergeProps } from '../../utils/with-default-props';
import classNames from 'classnames';
var classPrefix = "am-tag";
var colorRecord = {
  "default": '#666666',
  primary: '#1677FF'
};
var defaultProps = {
  color: 'default',
  fill: 'solid',
  round: false
};
export var Tag = function Tag(p) {
  var _classNames;

  var _a;

  var props = mergeProps(defaultProps, p);
  var color = (_a = colorRecord[props.color]) !== null && _a !== void 0 ? _a : props.color;
  var style = Object.assign({
    '--color': color
  }, props.style);
  return /*#__PURE__*/React.createElement("span", {
    style: style,
    className: classNames(classPrefix, (_classNames = {}, _classNames[classPrefix + "-round"] = props.round, _classNames[classPrefix + "-outline"] = props.fill === 'outline', _classNames), props.className)
  }, props.children);
};